Add-Type -Name Window -Namespace Console -MemberDefinition '
[DllImport("Kernel32.dll")]
public static extern IntPtr GetConsoleWindow();
[DllImport("user32.dll")]
public static extern bool ShowWindow(IntPtr hWnd, Int32 nCmdShow);
'
$consolePtr = [Console.Window]::GetConsoleWindow()
[Console.Window]::ShowWindow($consolePtr, 0)
$source = @"
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace KeyboardSend
{
    public class KeyboardSend
    {
        [DllImport("user32.dll")]
        public static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);
        private const int KEYEVENTF_EXTENDEDKEY = 1;
        private const int KEYEVENTF_KEYUP = 2;
        public static void KeyDown(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY, 0);
        }
        public static void KeyUp(Keys vKey)
        {
            keybd_event((byte)vKey, 0, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
        }
    }
}
"@
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Drawing"
Add-Type -TypeDefinition $source -ReferencedAssemblies "System.Windows.Forms"



$R1C1 = New-Object System.Drawing.Size(0,0)
$R1C2 = New-Object System.Drawing.Size(64,0)
$R1C3 = New-Object System.Drawing.Size(128,0)
$R1C4 = New-Object System.Drawing.Size(192,0)
$R1C5 = New-Object System.Drawing.Size(256,0)
$R1C6 = New-Object System.Drawing.Size(320,0)
$R1C7 = New-Object System.Drawing.Size(384,0)
$R1C8 = New-Object System.Drawing.Size(448,0)
$R1C9 = New-Object System.Drawing.Size(512,0)
$R1C10 = New-Object System.Drawing.Size(576,0)
$R2C1 = New-Object System.Drawing.Size(0,64)
$R2C2 = New-Object System.Drawing.Size(64,64)
$R2C3 = New-Object System.Drawing.Size(128,64)
$R2C4 = New-Object System.Drawing.Size(192,64)
$R2C5 = New-Object System.Drawing.Size(256,64)
$R2C6 = New-Object System.Drawing.Size(320,64)
$R2C7 = New-Object System.Drawing.Size(384,64)
$R2C8 = New-Object System.Drawing.Size(448,64)
$R2C9 = New-Object System.Drawing.Size(512,64)
$R2C10 = New-Object System.Drawing.Size(576,64)
$R3C1 = New-Object System.Drawing.Size(0,128)
$R3C2 = New-Object System.Drawing.Size(64,128)
$R3C3 = New-Object System.Drawing.Size(128,128)
$R3C4 = New-Object System.Drawing.Size(192,128)
$R3C5 = New-Object System.Drawing.Size(256,128)
$R3C6 = New-Object System.Drawing.Size(320,128)
$R3C7 = New-Object System.Drawing.Size(384,128)
$R3C8 = New-Object System.Drawing.Size(448,128)
$R3C9 = New-Object System.Drawing.Size(512,128)
$R3C10 = New-Object System.Drawing.Size(576,128)
$R4C1 = New-Object System.Drawing.Size(0,192)
$R4C2 = New-Object System.Drawing.Size(64,192)
$R4C3 = New-Object System.Drawing.Size(128,192)
$R4C4 = New-Object System.Drawing.Size(192,192)
$R4C5 = New-Object System.Drawing.Size(256,192)
$R4C6 = New-Object System.Drawing.Size(320,192)
$R4C7 = New-Object System.Drawing.Size(384,192)
$R4C8 = New-Object System.Drawing.Size(448,192)
$R4C9 = New-Object System.Drawing.Size(512,192)
$R4C10 = New-Object System.Drawing.Size(576,192)
$R5C1 = New-Object System.Drawing.Size(0,256)
$R5C2 = New-Object System.Drawing.Size(64,256)
$R5C3 = New-Object System.Drawing.Size(128,256)
$R5C4 = New-Object System.Drawing.Size(192,256)
$R5C5 = New-Object System.Drawing.Size(256,256)
$R5C6 = New-Object System.Drawing.Size(320,256)
$R5C7 = New-Object System.Drawing.Size(384,256)
$R5C8 = New-Object System.Drawing.Size(448,256)
$R5C9 = New-Object System.Drawing.Size(512,256)
$R5C10 = New-Object System.Drawing.Size(576,256)
$R6C1 = New-Object System.Drawing.Size(0,320)
$R6C2 = New-Object System.Drawing.Size(64,320)
$R6C3 = New-Object System.Drawing.Size(128,320)
$R6C4 = New-Object System.Drawing.Size(192,320)
$R6C5 = New-Object System.Drawing.Size(256,320)
$R6C6 = New-Object System.Drawing.Size(320,320)
$R6C7 = New-Object System.Drawing.Size(384,320)
$R6C8 = New-Object System.Drawing.Size(448,320)
$R6C9 = New-Object System.Drawing.Size(512,320)
$R6C10 = New-Object System.Drawing.Size(576,320)
$R7C1 = New-Object System.Drawing.Size(0,384)
$R7C2 = New-Object System.Drawing.Size(64,384)
$R7C3 = New-Object System.Drawing.Size(128,384)
$R7C4 = New-Object System.Drawing.Size(192,384)
$R7C5 = New-Object System.Drawing.Size(256,384)
$R7C6 = New-Object System.Drawing.Size(320,384)
$R7C7 = New-Object System.Drawing.Size(384,384)
$R7C8 = New-Object System.Drawing.Size(448,384)
$R7C9 = New-Object System.Drawing.Size(512,384)
$R7C10 = New-Object System.Drawing.Size(576,384)
$R8C1 = New-Object System.Drawing.Size(0,448)
$R8C2 = New-Object System.Drawing.Size(64,448)
$R8C3 = New-Object System.Drawing.Size(128,448)
$R8C4 = New-Object System.Drawing.Size(192,448)
$R8C5 = New-Object System.Drawing.Size(256,448)
$R8C6 = New-Object System.Drawing.Size(320,448)
$R8C7 = New-Object System.Drawing.Size(384,448)
$R8C8 = New-Object System.Drawing.Size(448,448)
$R8C9 = New-Object System.Drawing.Size(512,448)
$R8C10 = New-Object System.Drawing.Size(576,448)
$R9C1 = New-Object System.Drawing.Size(0,512)
$R9C2 = New-Object System.Drawing.Size(64,512)
$R9C3 = New-Object System.Drawing.Size(128,512)
$R9C4 = New-Object System.Drawing.Size(192,512)
$R9C5 = New-Object System.Drawing.Size(256,512)
$R9C6 = New-Object System.Drawing.Size(320,512)
$R9C7 = New-Object System.Drawing.Size(384,512)
$R9C8 = New-Object System.Drawing.Size(448,512)
$R9C9 = New-Object System.Drawing.Size(512,512)
$R9C10 = New-Object System.Drawing.Size(576,512)
$R10C1 = New-Object System.Drawing.Size(0,576)
$R10C2 = New-Object System.Drawing.Size(64,576)
$R10C3 = New-Object System.Drawing.Size(128,576)
$R10C4 = New-Object System.Drawing.Size(192,576)
$R10C5 = New-Object System.Drawing.Size(256,576)
$R10C6 = New-Object System.Drawing.Size(320,576)
$R10C7 = New-Object System.Drawing.Size(384,576)
$R10C8 = New-Object System.Drawing.Size(448,576)
$R10C9 = New-Object System.Drawing.Size(512,576)
$R10C10 = New-Object System.Drawing.Size(576,576)



$BorderFixedSimple = [System.Windows.Forms.FormBorderStyle]::FixedSingle
$FlatButton = [System.Windows.Forms.FlatStyle]::Flat
$PopButton = [System.Windows.Forms.FlatStyle]::Standard
$CurrentIdentity = [Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()
$HostName = [System.Net.Dns]::GetHostName()
$BatchFileLocation = $PSScriptRoot + "\runme.bat"
$CurrentUserAppTextFile = $PSScriptRoot + "\test_currentuser_" + $HostName + ".txt"
$AllUserAppTextFile = $PSScriptRoot + "\test_alluser_" + $HostName + ".txt"
$AppTextFiles = $PSScriptRoot + "\test_*_" + $HostName + ".txt"
$WSResetIcon = [system.drawing.icon]::ExtractAssociatedIcon("C:\Windows\System32\WSReset.exe")
$Default = [System.Drawing.Image]::FromFile($PSScriptRoot + "\Default.png")
$WiFi = [System.Drawing.Image]::FromFile($PSScriptRoot + "\WiFi.png")



$DefaultForm = New-Object System.Windows.Forms.Form
$DefaultForm.FormBorderStyle = $BorderFixedSimple
$DefaultForm.StartPosition = "CenterScreen"
$DefaultForm.WindowState = "Normal"
$DefaultForm.Size = New-Object System.Drawing.Size(592,488)
$DefaultForm.Text = "Multi-Function Script By MarioMasta64"
$DefaultForm.Icon = $WSResetIcon
$DefaultForm.MaximizeBox = $False
$DefaultForm.SizeGripStyle = "Hide"

$DefaultPanel = New-Object System.Windows.Forms.Panel
$DefaultPanel.Location = $R1C1
$DefaultPanel.Size = $R10C10
$DefaultPanel.Visible = $True
$DefaultForm.Controls.Add($DefaultPanel)



$DefaultTextBox = New-Object System.Windows.Forms.TextBox
$DefaultTextBox.Location = $R3C1
$DefaultTextBox.Size = $R5C10
$DefaultTextBox.Font = New-Object System.Drawing.Font("Consolas", 8 ,[System.Drawing.FontStyle]::Regular)
$DefaultTextBox.MultiLine = $True
$DefaultTextBox.ScrollBars = "Vertical"
$DefaultTextBox.ReadOnly = $True
$DefaultTextBox.HideSelection = $False
$DefaultPanel.Controls.Add($DefaultTextBox)


# $ComputerSystemDomain = (Get-WmiObject -Class:Win32_ComputerSystem).Domain;
# $ComputerSystemManufacturer = (Get-WmiObject -Class:Win32_ComputerSystem).Manufacturer;
# $ComputerSystemModel = (Get-WmiObject -Class:Win32_ComputerSystem).Model;
# $ComputerSystemName = (Get-WmiObject -Class:Win32_ComputerSystem).Name;
# $ComputerSystemPrimaryOwnerName = (Get-WmiObject -Class:Win32_ComputerSystem).PrimaryOwnerName;
# $ComputerSystemTotalPhysicalMemory = (Get-WmiObject -Class:Win32_ComputerSystem).TotalPhysicalMemory;

# $BIOSSMBIOSBIOSVersion = (Get-WmiObject -Class:Win32_BIOS).SMBIOSBIOSVersion;
# $BIOSManufacturer = (Get-WmiObject -Class:Win32_BIOS).Manufacturer;
# $BIOSName = (Get-WmiObject -Class:Win32_BIOS).Name;
# $BIOSSerialNumber = (Get-WmiObject -Class:Win32_BIOS).SerialNumber;
# $BIOSVersion = (Get-WmiObject -Class:Win32_BIOS).Version;


Function GetWiFiPasswords { $WiFiPasswords = (netsh wlan show profiles) | Select-String "\:(.+)$" | %{$name=$_.Matches.Groups[1].Value.Trim(); $_} | %{(netsh wlan show profile name="$name" key=clear)} | Select-String "Key Content\W+\:(.+)$" | %{$pass=$_.Matches.Groups[1].Value.Trim(); $_} | %{[PSCustomObject]@{ SSID=$name;PASSWORD=$pass }} | Format-Table -AutoSize | Out-String; OutputText "$WiFiPasswords"; Return; };
# Function GetWiFiPasswords { $WiFiPasswords = (netsh wlan show profiles) | Out-String; OutputText "$WiFiPasswords"; Return; };
Function GetComputerSystemInfo { $ComputerSystemInfo = (Get-WmiObject -Class:Win32_ComputerSystem) | Out-String; OutputText "$ComputerSystemInfo"; Return; };
Function GetBIOSInfo { $BIOSInfo = (Get-WmiObject -Class:Win32_BIOS) | Out-String; OutputText "$BIOSInfo"; Return; };
Function GetPhysicalMemoryInfo { $PhysicalMemory = (Get-WmiObject -Class:Win32_PhysicalMemory) | Out-String; OutputText "$PhysicalMemory"; Return; };

Function Debug {
	$DebugText = (Get-WmiObject -Class:Win32_ComputerSystemProduct).Name; OutputText "$DebugText";
	$DebugText = (Get-WmiObject -Class:Win32_ComputerSystemProduct).IdentifyingNumber; OutputText "$DebugText";
Return; };

Function ProductWebPage {
	$LenovoSystemModel = (Get-WmiObject -Class:Win32_ComputerSystemProduct).Name;
	$LenovoSerialNumber = (Get-WmiObject -Class:Win32_ComputerSystemProduct).IdentifyingNumber;
    $ComputerSystemManufacturer = (Get-WmiObject -Class:Win32_ComputerSystem).Manufacturer;
    $ComputerSystemModel = (Get-WmiObject -Class:Win32_ComputerSystem).Model;
    $BIOSSerialNumber = (Get-WmiObject -Class:Win32_BIOS).SerialNumber;
	
	# $ComputerSystemManufacturer = "Acer";
	# $BIOSSerialNumber = "NUSH7AA004305279A51601";
	# $ComputerSystemManufacturer = "Lenovo";
	# $LenovoSystemModel = "20dt001dus";
	# $LenovoSerialNumber = "pf0crv3l";
	# $LenovoSystemType = $LenovoSystemModel.SubString(0,4)
	
	If (("$ComputerSystemManufacturer" -Match "Acer") -Or ("$ComputerSystemManufacturer" -Match "Lenovo")) {
		Switch ("$ComputerSystemManufacturer") {
			"Acer" { OutputText "Paste This: $BIOSSerialNumber (May Be Copied To ClipBoard)`r`n"; Set-Clipboard -Value "$BIOSSerialNumber"; Break;};
			"Lenovo" { OutputText "Paste This: $LenovoSerialNumber (May Be Copied To ClipBoard)`r`n"; Set-Clipboard -Value "$LenovoSerialNumber"; Break;};
		};
		Start-Sleep -Seconds 3.5;
	};
	
	# Browse "https://www.acer.com/ac/en/US/content/drivers"
	# Browse "https://www.dell.com/support/home/us/en/04/products?app=drivers";
	# Browse "https://support.hp.com/us-en/drivers/laptops";
	# Browse "https://support.lenovo.com/us/en/";
	
	# Switch Compares A Value To Another
	# Exa: MarioMasta64 & "io" would return false while "*io*" true
	# the action is on right and break cancels whatever is doing inside
	# so "Return;" would be ran but switch will stop searching other values
	Switch ("$ComputerSystemManufacturer") {
		"Acer" { Browse "https://www.acer.com/ac/en/US/content/drivers"; Break; };
        "Dell" { Browse "https://www.dell.com/support/home/us/en/04/product-support/servicetag/$BIOSSerialNumber/drivers"; Break; };
        "Dell Inc." { Browse "https://www.dell.com/support/home/us/en/04/product-support/servicetag/$BIOSSerialNumber/drivers"; Break; };
		# Browse "https://support.hp.com/us-en/drivers/selfservice/identify?q=$BIOSSerialNumber&filter=-1&origin=drivers&type=others";
		"HP" { Browse "https://support.hp.com/us-en/drivers/selfservice/model/$Model"; Break; };
		"Hewlett-Packard" { Browse "https://support.hp.com/us-en/drivers/selfservice/model/$Model"; Break; };
		# https://pcsupport.lenovo.com/us/en/products/laptops-and-netbooks/thinkpad-l-series-laptops/thinkpad-l450/20dt/20dt001dus/pf0crv3l?linkTrack=Homepage%3ABody_Search%20Products&searchType=6&keyWordSearch=pf0crv3l
		# https://pcsupport.lenovo.com/us/en/products/laptops-and-netbooks/thinkpad-l-series-laptops/thinkpad-l450/20dt/20dt001dus/pf0crv3l/downloads?linkTrack=Caps%3ABody_SearchProduct&searchType=6&keyWordSearch=PF0CRV3L
		# https://pcsupport.lenovo.com/us/en/products/laptops-and-netbooks/4286/4286cto/downloads?linkTrack=Caps%3ABody_SearchProduct&searchType=5&keyWordSearch=4286CTO
		"Lenovo" { Browse "https://support.lenovo.com/us/en/"; Break; };
		Default { OutputText "[ $ComputerSystemManufacturer ] Is Not Implemented Currently`r`n"; Break; };
	};
	
    Return;
};

Function ReloadPowerShellFile { & $BatchFileLocation; ExitScript; Return; };
Function BecomeAdmin { Start-Process powershell.exe "-Windowstyle Hidden -NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs; ExitScript; Return; };

Function Browse { [System.Diagnostics.Process]::Start("$args"); Return; };
Function OutputText { $DefaultTextBox.AppendText("$args"); $DefaultTextBox.Refresh(); Return; };
Function OpenStartMenu { [KeyboardSend.KeyboardSend]::KeyDown("LWin"); [KeyboardSend.KeyboardSend]::KeyUp("LWin"); Return; };
Function KillExplorer { & cmd /c `"taskkill /f /im explorer.exe`"; Return; };
Function StartExplorer { & explorer.exe; Return; };
Function ExitScript { $consolePtr.Close(); Stop-Process $PID };



$Button11 = New-Object System.Windows.Forms.Button
$Button11.Location = $R1C1
$Button11.Size = $R2C2
$Button11.Image = $ComputerSystem
$Button11.Text = "System`r`nInfo"
$Button11.BackgroundImageLayout = "Zoom"
$Button11.Add_Click({ GetComputerSystemInfo })
$Button11.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button11)

$Button12 = New-Object System.Windows.Forms.Button
$Button12.Location = $R1C2
$Button12.Size = $R2C2
$Button12.Image = $BIOS
$Button12.Text = "Bios`r`nInfo"
$Button12.BackgroundImageLayout = "Zoom"
$Button12.Add_Click({ GetBIOSInfo })
$Button12.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button12)

$Button13 = New-Object System.Windows.Forms.Button
$Button13.Location = $R1C3
$Button13.Size = $R2C2
$Button13.Image = $PhysicalMemory
$Button13.Text = "Physical`r`nMemory`r`nInfo"
$Button13.BackgroundImageLayout = "Zoom"
$Button13.Add_Click({ GetPhysicalMemoryInfo })
$Button13.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button13)

$Button21 = New-Object System.Windows.Forms.Button
$Button21.Location = $R2C1
$Button21.Size = $R2C2
$Button21.Image = $WiFi
$Button21.BackgroundImageLayout = "Zoom"
$Button21.Add_Click({ GetWiFiPasswords })
$Button21.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button21)

$Button22 = New-Object System.Windows.Forms.Button
$Button22.Location = $R2C2
$Button22.Size = $R2C2
$Button22.Image = $ProductWebPage
$Button22.Text = "Product`r`nWebPage"
$Button22.BackgroundImageLayout = "Zoom"
$Button22.Add_Click({ ProductWebPage })
$Button22.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button22)

$Button61 = New-Object System.Windows.Forms.Button
$Button61.Location = $R7C1
$Button61.Size = $R2C2
$Button61.Image = $Debug
$Button61.Text = "Debug"
$Button61.BackgroundImageLayout = "Zoom"
$Button61.Add_Click({ Debug })
$Button61.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button61)

$Button67 = New-Object System.Windows.Forms.Button
$Button67.Location = $R7C7
$Button67.Size = $R2C2
$Button67.Image = $Default
$Button67.BackgroundImageLayout = "Zoom"
$Button67.Text = "Reload"
$Button67.Add_Click({ ReloadPowerShellFile })
$Button67.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button67)

$Button68 = New-Object System.Windows.Forms.Button
$Button68.Location = $R7C8
$Button68.Size = $R2C2
$Button68.Image = $Default
$Button68.BackgroundImageLayout = "Zoom"
$Button68.Text = "Become`r`nAdmin"
$Button68.Add_Click({ BecomeAdmin })
$Button68.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button68)

$Button69 = New-Object System.Windows.Forms.Button
$Button69.Location = $R7C9
$Button69.Size = $R2C2
$Button69.Image = $Default
$Button69.BackgroundImageLayout = "Zoom"
$Button69.Text = "Exit"
$Button69.Add_Click({ ExitScript })
$Button69.Cursor = [System.Windows.Forms.Cursors]::Hand
$DefaultPanel.Controls.Add($Button69)



$DefaultForm.Add_Shown({$DefaultForm.Activate()})
[void] $DefaultForm.ShowDialog()